<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for KPazarlamaci StructType
 * @subpackage Structs
 */
class KPazarlamaci extends Entity
{
    /**
     * The IsEmail
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsEmail;
    /**
     * The IsSms
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $IsSms;
    /**
     * The Firma
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Firma;
    /**
     * The Unvan
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Unvan;
    /**
     * The Kodu
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Kodu;
    /**
     * The SirketCarisi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KCariPointer
     */
    public $SirketCarisi;
    /**
     * The Email
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Email;
    /**
     * The CepTel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $CepTel;
    /**
     * The IsTel
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $IsTel;
    /**
     * The Sube
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\KSubePointer
     */
    public $Sube;
    /**
     * The Aciklama
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Aciklama;
    /**
     * Constructor method for KPazarlamaci
     * @uses KPazarlamaci::setIsEmail()
     * @uses KPazarlamaci::setIsSms()
     * @uses KPazarlamaci::setFirma()
     * @uses KPazarlamaci::setUnvan()
     * @uses KPazarlamaci::setKodu()
     * @uses KPazarlamaci::setSirketCarisi()
     * @uses KPazarlamaci::setEmail()
     * @uses KPazarlamaci::setCepTel()
     * @uses KPazarlamaci::setIsTel()
     * @uses KPazarlamaci::setSube()
     * @uses KPazarlamaci::setAciklama()
     * @param bool $isEmail
     * @param bool $isSms
     * @param string $firma
     * @param string $unvan
     * @param string $kodu
     * @param \fk_\StructType\KCariPointer $sirketCarisi
     * @param string $email
     * @param string $cepTel
     * @param string $isTel
     * @param \fk_\StructType\KSubePointer $sube
     * @param string $aciklama
     */
    public function __construct($isEmail = null, $isSms = null, $firma = null, $unvan = null, $kodu = null, \fk_\StructType\KCariPointer $sirketCarisi = null, $email = null, $cepTel = null, $isTel = null, \fk_\StructType\KSubePointer $sube = null, $aciklama = null)
    {
        $this
            ->setIsEmail($isEmail)
            ->setIsSms($isSms)
            ->setFirma($firma)
            ->setUnvan($unvan)
            ->setKodu($kodu)
            ->setSirketCarisi($sirketCarisi)
            ->setEmail($email)
            ->setCepTel($cepTel)
            ->setIsTel($isTel)
            ->setSube($sube)
            ->setAciklama($aciklama);
    }
    /**
     * Get IsEmail value
     * @return bool
     */
    public function getIsEmail()
    {
        return $this->IsEmail;
    }
    /**
     * Set IsEmail value
     * @param bool $isEmail
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setIsEmail($isEmail = null)
    {
        // validation for constraint: boolean
        if (!is_null($isEmail) && !is_bool($isEmail)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isEmail, true), gettype($isEmail)), __LINE__);
        }
        $this->IsEmail = $isEmail;
        return $this;
    }
    /**
     * Get IsSms value
     * @return bool
     */
    public function getIsSms()
    {
        return $this->IsSms;
    }
    /**
     * Set IsSms value
     * @param bool $isSms
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setIsSms($isSms = null)
    {
        // validation for constraint: boolean
        if (!is_null($isSms) && !is_bool($isSms)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($isSms, true), gettype($isSms)), __LINE__);
        }
        $this->IsSms = $isSms;
        return $this;
    }
    /**
     * Get Firma value
     * @return string|null
     */
    public function getFirma()
    {
        return $this->Firma;
    }
    /**
     * Set Firma value
     * @param string $firma
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setFirma($firma = null)
    {
        // validation for constraint: string
        if (!is_null($firma) && !is_string($firma)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($firma, true), gettype($firma)), __LINE__);
        }
        $this->Firma = $firma;
        return $this;
    }
    /**
     * Get Unvan value
     * @return string|null
     */
    public function getUnvan()
    {
        return $this->Unvan;
    }
    /**
     * Set Unvan value
     * @param string $unvan
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setUnvan($unvan = null)
    {
        // validation for constraint: string
        if (!is_null($unvan) && !is_string($unvan)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($unvan, true), gettype($unvan)), __LINE__);
        }
        $this->Unvan = $unvan;
        return $this;
    }
    /**
     * Get Kodu value
     * @return string|null
     */
    public function getKodu()
    {
        return $this->Kodu;
    }
    /**
     * Set Kodu value
     * @param string $kodu
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setKodu($kodu = null)
    {
        // validation for constraint: string
        if (!is_null($kodu) && !is_string($kodu)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($kodu, true), gettype($kodu)), __LINE__);
        }
        $this->Kodu = $kodu;
        return $this;
    }
    /**
     * Get SirketCarisi value
     * @return \fk_\StructType\KCariPointer|null
     */
    public function getSirketCarisi()
    {
        return $this->SirketCarisi;
    }
    /**
     * Set SirketCarisi value
     * @param \fk_\StructType\KCariPointer $sirketCarisi
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setSirketCarisi(\fk_\StructType\KCariPointer $sirketCarisi = null)
    {
        $this->SirketCarisi = $sirketCarisi;
        return $this;
    }
    /**
     * Get Email value
     * @return string|null
     */
    public function getEmail()
    {
        return $this->Email;
    }
    /**
     * Set Email value
     * @param string $email
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setEmail($email = null)
    {
        // validation for constraint: string
        if (!is_null($email) && !is_string($email)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email, true), gettype($email)), __LINE__);
        }
        $this->Email = $email;
        return $this;
    }
    /**
     * Get CepTel value
     * @return string|null
     */
    public function getCepTel()
    {
        return $this->CepTel;
    }
    /**
     * Set CepTel value
     * @param string $cepTel
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setCepTel($cepTel = null)
    {
        // validation for constraint: string
        if (!is_null($cepTel) && !is_string($cepTel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($cepTel, true), gettype($cepTel)), __LINE__);
        }
        $this->CepTel = $cepTel;
        return $this;
    }
    /**
     * Get IsTel value
     * @return string|null
     */
    public function getIsTel()
    {
        return $this->IsTel;
    }
    /**
     * Set IsTel value
     * @param string $isTel
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setIsTel($isTel = null)
    {
        // validation for constraint: string
        if (!is_null($isTel) && !is_string($isTel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($isTel, true), gettype($isTel)), __LINE__);
        }
        $this->IsTel = $isTel;
        return $this;
    }
    /**
     * Get Sube value
     * @return \fk_\StructType\KSubePointer|null
     */
    public function getSube()
    {
        return $this->Sube;
    }
    /**
     * Set Sube value
     * @param \fk_\StructType\KSubePointer $sube
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setSube(\fk_\StructType\KSubePointer $sube = null)
    {
        $this->Sube = $sube;
        return $this;
    }
    /**
     * Get Aciklama value
     * @return string|null
     */
    public function getAciklama()
    {
        return $this->Aciklama;
    }
    /**
     * Set Aciklama value
     * @param string $aciklama
     * @return \fk_\StructType\KPazarlamaci
     */
    public function setAciklama($aciklama = null)
    {
        // validation for constraint: string
        if (!is_null($aciklama) && !is_string($aciklama)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($aciklama, true), gettype($aciklama)), __LINE__);
        }
        $this->Aciklama = $aciklama;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\KPazarlamaci
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
