<?php

namespace fk_\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for MuhasebeHesabiBakiyesi StructType
 * @subpackage Structs
 */
class MuhasebeHesabiBakiyesi extends Bakiye
{
    /**
     * The UstHesapMi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $UstHesapMi;
    /**
     * The MuhasebeHesabi
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \fk_\StructType\MuhasebeHesabiPointer
     */
    public $MuhasebeHesabi;
    /**
     * Constructor method for MuhasebeHesabiBakiyesi
     * @uses MuhasebeHesabiBakiyesi::setUstHesapMi()
     * @uses MuhasebeHesabiBakiyesi::setMuhasebeHesabi()
     * @param bool $ustHesapMi
     * @param \fk_\StructType\MuhasebeHesabiPointer $muhasebeHesabi
     */
    public function __construct($ustHesapMi = null, \fk_\StructType\MuhasebeHesabiPointer $muhasebeHesabi = null)
    {
        $this
            ->setUstHesapMi($ustHesapMi)
            ->setMuhasebeHesabi($muhasebeHesabi);
    }
    /**
     * Get UstHesapMi value
     * @return bool
     */
    public function getUstHesapMi()
    {
        return $this->UstHesapMi;
    }
    /**
     * Set UstHesapMi value
     * @param bool $ustHesapMi
     * @return \fk_\StructType\MuhasebeHesabiBakiyesi
     */
    public function setUstHesapMi($ustHesapMi = null)
    {
        // validation for constraint: boolean
        if (!is_null($ustHesapMi) && !is_bool($ustHesapMi)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($ustHesapMi, true), gettype($ustHesapMi)), __LINE__);
        }
        $this->UstHesapMi = $ustHesapMi;
        return $this;
    }
    /**
     * Get MuhasebeHesabi value
     * @return \fk_\StructType\MuhasebeHesabiPointer|null
     */
    public function getMuhasebeHesabi()
    {
        return $this->MuhasebeHesabi;
    }
    /**
     * Set MuhasebeHesabi value
     * @param \fk_\StructType\MuhasebeHesabiPointer $muhasebeHesabi
     * @return \fk_\StructType\MuhasebeHesabiBakiyesi
     */
    public function setMuhasebeHesabi(\fk_\StructType\MuhasebeHesabiPointer $muhasebeHesabi = null)
    {
        $this->MuhasebeHesabi = $muhasebeHesabi;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \fk_\StructType\MuhasebeHesabiBakiyesi
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
